﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.Mvc;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using GestioHospitalaria;
using GestioHospitalaria.Controllers;
using GestioHospitalaria.Tests;
using GestioHospitalaria.Tests.Models;
using GestioHospitalaria.Models;
using System.Web.Routing;
using System.Web;
using System.Security.Principal;
using GestioHospitalaria.Auxiliar;
using MvcContrib.TestHelper;
using System.Data.SqlClient;

namespace GestioHospitalaria.Integracio.Test.Tests
{
    [TestClass]
    public class Dosi_Test
    {
        EntityGestioHospitalariaManagerRepository EDB = new EntityGestioHospitalariaManagerRepository();
 
        //creem una nova dosi
        [TestMethod]
        public void CreateDosi_DeleteDosi()
        {
            // Arrange
            DosiController controller = new DosiController(EDB);
            TestControllerBuilder builder = new TestControllerBuilder();
            builder.InitializeController(controller);
            Dosi model = new Dosi
            {
                ID_Dosi = 0,
                Unitat = "ProvaTest001",
                Valor = 999
            };
            controller.HttpContext.Session["IDTipusEmpleat"] = 2;//Donem poders de creació de dosis
            //CREEM UNA NOVA DOSI
            // Act
            var resultLogin = (RedirectToRouteResult)controller.Create(model);
            string consultaBD = "Select * from Dosi where ID_Dosi=" +model.ID_Dosi;
            SqlDataReader dr = Auxiliar.Auxiliar.findRecord(consultaBD);
            // Assert

            Assert.AreEqual("Index", resultLogin.RouteValues["action"]);//tormen a la pàgina principal de dosis

            //verifiquem que existeix el registre a la base de dades
            Assert.AreEqual(true, dr.HasRows);

            //Començem a eliminar

            resultLogin = (RedirectToRouteResult)controller.DeleteConfirmed(model.ID_Dosi);
            Assert.AreEqual("Index", resultLogin.RouteValues["action"]);//tormen a la pàgina principal de dosis

            //verifiquem que existeix NO el registre a la base de dades, que l'hem eliminat
            dr = Auxiliar.Auxiliar.findRecord(consultaBD);
            Assert.AreEqual(false, dr.HasRows);

        }
    }
}
