﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.Mvc;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using GestioHospitalaria;
using GestioHospitalaria.Controllers;
using GestioHospitalaria.Tests;
using GestioHospitalaria.Tests.Models;
using GestioHospitalaria.Models;
using System.Web.Routing;
using System.Web;
using System.Security.Principal;
using GestioHospitalaria.Auxiliar;
using MvcContrib.TestHelper;
using System.Data.SqlClient;

namespace GestioHospitalaria.Integracio.Test.Tests
{
    [TestClass]
    public class EstatReserva_Test
    {
        EntityGestioHospitalariaManagerRepository EDB = new EntityGestioHospitalariaManagerRepository();

        //creem un nou EstatReserva
        [TestMethod]
        public void CreateEstatReserva_DeleteEstatReserva()
        {
            // Arrange
            EstatReservaController controller = new EstatReservaController(EDB);
            TestControllerBuilder builder = new TestControllerBuilder();
            builder.InitializeController(controller);
            EstatReserva model = new EstatReserva
            {
                ID_EstatReserva = 0,
                Descripcio = "ProvaTest001"
            };
            controller.HttpContext.Session["IDTipusEmpleat"] = 1;//Donem poders de creació d'EstatReservas
            //CREEM UN NOU EstatReserva
            // Act
            var resultLogin = (RedirectToRouteResult)controller.Create(model);
            string consultaBD = "Select * from EstatReserva where ID_EstatReserva=" + model.ID_EstatReserva;
            SqlDataReader dr = Auxiliar.Auxiliar.findRecord(consultaBD);
            // Assert

            Assert.AreEqual("Index", resultLogin.RouteValues["action"]);//tormen a la pàgina principal d'EstatReservas

            //verifiquem que existeix el registre a la base de dades
            Assert.AreEqual(true, dr.HasRows);

            //Començem a eliminar

            resultLogin = (RedirectToRouteResult)controller.DeleteConfirmed(model.ID_EstatReserva);
            Assert.AreEqual("Index", resultLogin.RouteValues["action"]);//tormen a la pàgina principal d'EstatReservas

            //verifiquem que NO existeix el registre a la base de dades, que l'hem eliminat
            dr = Auxiliar.Auxiliar.findRecord(consultaBD);
            Assert.AreEqual(false, dr.HasRows);

        }
    }
}
