﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.Mvc;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using GestioHospitalaria;
using GestioHospitalaria.Controllers;
using GestioHospitalaria.Tests;
using GestioHospitalaria.Tests.Models;
using GestioHospitalaria.Models;
using System.Web.Routing;
using System.Web;
using System.Security.Principal;
using GestioHospitalaria.Auxiliar;
using MvcContrib.TestHelper;
using System.Data.SqlClient;
namespace GestioHospitalaria.Integracio.Test.Tests
{
    [TestClass]
    public class Habitacio_Test
    {
        EntityGestioHospitalariaManagerRepository EDB = new EntityGestioHospitalariaManagerRepository();

        //creem una nova Habitacio
        [TestMethod]
        public void CreateHabitacio_DeleteHabitacio()
        {
            // Arrange
            HabitacioController controller = new HabitacioController(EDB);
            TestControllerBuilder builder = new TestControllerBuilder();
            builder.InitializeController(controller);
            Habitacio model = new Habitacio
            {
                ID_Habitacio = 0,
                Descripcio = "ProvaTest001"
            };
            controller.HttpContext.Session["IDTipusEmpleat"] = 1;//Donem poders de creació d'Habitacions
            //Creem una nova Habitacio
            // Act
            var resultLogin = (RedirectToRouteResult)controller.Create(model);
            string consultaBD = "Select * from Habitacio where ID_Habitacio=" + model.ID_Habitacio;
            SqlDataReader dr = Auxiliar.Auxiliar.findRecord(consultaBD);
            // Assert

            Assert.AreEqual("Index", resultLogin.RouteValues["action"]);//tormen a la pàgina principal d'Habitacions

            //verifiquem que existeix el registre a la base de dades
            Assert.AreEqual(true, dr.HasRows);

            //Començem a eliminar

            resultLogin = (RedirectToRouteResult)controller.DeleteConfirmed(model.ID_Habitacio);
            Assert.AreEqual("Index", resultLogin.RouteValues["action"]);//tormen a la pàgina principal d'Habitacions

            //verifiquem que NO existeix el registre a la base de dades, que l'hem eliminat.
            dr = Auxiliar.Auxiliar.findRecord(consultaBD);
            Assert.AreEqual(false, dr.HasRows);

        }
    }
}
