﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.Mvc;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using GestioHospitalaria;
using GestioHospitalaria.Controllers;
using GestioHospitalaria.Tests;
using GestioHospitalaria.Tests.Models;
using GestioHospitalaria.Models;
using System.Web.Routing;
using System.Web;
using System.Security.Principal;
using GestioHospitalaria.Auxiliar;
using MvcContrib.TestHelper;
using System.Data.SqlClient;

namespace GestioHospitalaria.Integracio.Test.Tests
{
    [TestClass]
    public class Medicament_Test
    {
        EntityGestioHospitalariaManagerRepository EDB = new EntityGestioHospitalariaManagerRepository();

        //creem una nova Medicament
        [TestMethod]
        public void CreateMedicament_DeleteMedicament()
        {
            // Arrange
            MedicamentController controller = new MedicamentController(EDB);
            TestControllerBuilder builder = new TestControllerBuilder();
            builder.InitializeController(controller);
            Medicament model = new Medicament
            {
                ID_Medicament = 0,
                Descripcio = "ProvaTest001"
            };
            controller.HttpContext.Session["IDTipusEmpleat"] = 3;//Donem poders de creació de Medicaments
            //Creem una nova Medicament
            // Act
            var resultLogin = (RedirectToRouteResult)controller.Create(model);
            string consultaBD = "Select * from Medicament where ID_Medicament=" + model.ID_Medicament;
            SqlDataReader dr = Auxiliar.Auxiliar.findRecord(consultaBD);
            // Assert

            Assert.AreEqual("Index", resultLogin.RouteValues["action"]);//tormen a la pàgina principal de Medicaments

            //verifiquem que existeix el registre a la base de dades
            Assert.AreEqual(true, dr.HasRows);

            //Començem a eliminar

            resultLogin = (RedirectToRouteResult)controller.DeleteConfirmed(model.ID_Medicament);
            Assert.AreEqual("Index", resultLogin.RouteValues["action"]);//tormen a la pàgina principal de Medicaments

            //verifiquem que NO existeix el registre a la base de dades, que l'hem eliminat.
            dr = Auxiliar.Auxiliar.findRecord(consultaBD);
            Assert.AreEqual(false, dr.HasRows);

        }
    }
}
