﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.Mvc;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using GestioHospitalaria;
using GestioHospitalaria.Controllers;
using GestioHospitalaria.Tests;
using GestioHospitalaria.Tests.Models;
using GestioHospitalaria.Models;
using System.Web.Routing;
using System.Web;
using System.Security.Principal;
using GestioHospitalaria.Auxiliar;
using MvcContrib.TestHelper;
using System.Data.SqlClient;
using MvcContrib.TestHelper.Fakes;

namespace GestioHospitalaria.Integracio.Test.Tests
{
    [TestClass]
    public class Ordre_Test
    {
        EntityGestioHospitalariaManagerRepository EDB = new EntityGestioHospitalariaManagerRepository();

        //creem una nova Ordre
        [TestMethod]
        public void CreateOrdre_DeleteOrdre()
        {
            // Arrange
            OrdreController controller = new OrdreController(EDB);
            TestControllerBuilder builder = new TestControllerBuilder();
            builder.HttpContext.User = new FakePrincipal(new FakeIdentity("Metge"), new string[] { "Role" });//actualitzem User.Identity.Name
            builder.InitializeController(controller);
            Ordre model = new Ordre
            {
                ID_Ordre = 0,
                ID_Pacient =1,
                ID_TipusOrdre=1,
                ID_Usuari=1,
                DataHoraInici = DateTime.Now,
                Durada=24
            };
            controller.HttpContext.Session["IDTipusEmpleat"] = 2;//Donem poders de creació d'Ordres

            //Creem una nova Ordre
            // Act
            var resultLogin = (RedirectToRouteResult)controller.Create(model);
            string consultaBD = "Select * from Ordre where ID_Ordre=" + model.ID_Ordre;
            SqlDataReader dr = Auxiliar.Auxiliar.findRecord(consultaBD);
            // Assert

            Assert.AreEqual("Index", resultLogin.RouteValues["action"]);//tormen a la pàgina principal d'Ordres

            //verifiquem que existeix el registre a la base de dades
            Assert.AreEqual(true, dr.HasRows);

            //Començem a eliminar

            resultLogin = (RedirectToRouteResult)controller.DeleteConfirmed(model.ID_Ordre);
            Assert.AreEqual("Index", resultLogin.RouteValues["action"]);//tormen a la pàgina principal d'Ordres

            //verifiquem que NO existeix el registre a la base de dades, que l'hem eliminat.
            dr = Auxiliar.Auxiliar.findRecord(consultaBD);
            Assert.AreEqual(false, dr.HasRows);

        }
    }
}
