﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.Mvc;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using GestioHospitalaria;
using GestioHospitalaria.Controllers;
using GestioHospitalaria.Tests;
using GestioHospitalaria.Tests.Models;
using GestioHospitalaria.Models;
using System.Web.Routing;
using System.Web;
using System.Security.Principal;
using GestioHospitalaria.Auxiliar;
using MvcContrib.TestHelper;
using System.Data.SqlClient;

namespace GestioHospitalaria.Integracio.Test.Tests
{
    [TestClass]
    public class Pacient_Test
    {
        EntityGestioHospitalariaManagerRepository EDB = new EntityGestioHospitalariaManagerRepository();

        //creem un nou Pacient
        [TestMethod]
        public void CreatePacient_DeletePacient()
        {
            // Arrange
            PacientController controller = new PacientController(EDB);
            TestControllerBuilder builder = new TestControllerBuilder();
            builder.InitializeController(controller);
            Pacient model = new Pacient
            {
                ID_Pacient = 0,
                Nom = "ProvaTest001",
                Targeta = "ProvaTest001"
            };
            controller.HttpContext.Session["IDTipusEmpleat"] = 4;//Donem poders de creació de Pacients
            //Creem un nou Pacient
            // Act
            var resultLogin = (RedirectToRouteResult)controller.Create(model);
            string consultaBD = "Select * from Pacient where ID_Pacient=" + model.ID_Pacient;
            SqlDataReader dr = Auxiliar.Auxiliar.findRecord(consultaBD);
            // Assert

            Assert.AreEqual("Index", resultLogin.RouteValues["action"]);//tormen a la pàgina principal de Pacients

            //verifiquem que existeix el registre a la base de dades
            Assert.AreEqual(true, dr.HasRows);

            //Començem a eliminar

            resultLogin = (RedirectToRouteResult)controller.DeleteConfirmed(model.ID_Pacient);
            Assert.AreEqual("Index", resultLogin.RouteValues["action"]);//tormen a la pàgina principal de Pacients

            //verifiquem que NO existeix el registre a la base de dades, que l'hem eliminat.
            dr = Auxiliar.Auxiliar.findRecord(consultaBD);
            Assert.AreEqual(false, dr.HasRows);

        }
    }
}
