﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.Mvc;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using GestioHospitalaria;
using GestioHospitalaria.Controllers;
using GestioHospitalaria.Tests;
using GestioHospitalaria.Tests.Models;
using GestioHospitalaria.Models;
using System.Web.Routing;
using System.Web;
using System.Security.Principal;
using GestioHospitalaria.Auxiliar;
using MvcContrib.TestHelper;
using System.Data.SqlClient;

namespace GestioHospitalaria.Integracio.Test.Tests
{
    [TestClass]
    public class TipusOrdre_Test
    {
        EntityGestioHospitalariaManagerRepository EDB = new EntityGestioHospitalariaManagerRepository();

        //creem un nou Tipus d'ordre
        [TestMethod]
        public void CreateTipusOrdre_DeleteTipusOrdre()
        {
            // Arrange
            TipusOrdreController controller = new TipusOrdreController(EDB);
            TestControllerBuilder builder = new TestControllerBuilder();
            builder.InitializeController(controller);
            TipusOrdre model = new TipusOrdre
            {
                ID_TipusOrdre = 0,
                Descripcio = "ProvaTest001"
            };
            controller.HttpContext.Session["IDTipusEmpleat"] = 1;//Donem poders de creació de Tipus d'ordres
            //Creem un nou TipusOrdre
            // Act
            var resultLogin = (RedirectToRouteResult)controller.Create(model);
            string consultaBD = "Select * from TipusOrdre where ID_TipusOrdre=" + model.ID_TipusOrdre;
            SqlDataReader dr = Auxiliar.Auxiliar.findRecord(consultaBD);
            // Assert

            Assert.AreEqual("Index", resultLogin.RouteValues["action"]);//tormen a la pàgina principal de Tipus d'ordres

            //verifiquem que existeix el registre a la base de dades
            Assert.AreEqual(true, dr.HasRows);

            //Començem a eliminar

            resultLogin = (RedirectToRouteResult)controller.DeleteConfirmed(model.ID_TipusOrdre);
            Assert.AreEqual("Index", resultLogin.RouteValues["action"]);//tormen a la pàgina principal de Tipus d'ordres

            //verifiquem que NO existeix el registre a la base de dades, que l'hem eliminat.
            dr = Auxiliar.Auxiliar.findRecord(consultaBD);
            Assert.AreEqual(false, dr.HasRows);

        }
    }
}
