﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.Mvc;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using GestioHospitalaria;
using GestioHospitalaria.Controllers;
using GestioHospitalaria.Tests;
using GestioHospitalaria.Tests.Models;
using GestioHospitalaria.Models;
using System.Web.Routing;
using System.Web;
using System.Security.Principal;
using GestioHospitalaria.Auxiliar;
using MvcContrib.TestHelper;
using System.Data.SqlClient;
using MvcContrib.TestHelper.Fakes;

namespace GestioHospitalaria.Integracio.Test.Tests
{
    [TestClass]
    public class Tractament_Test
    {
        EntityGestioHospitalariaManagerRepository EDB = new EntityGestioHospitalariaManagerRepository();

        //creem un nou Tractament
        [TestMethod]
        public void CreateTractament_DeleteTractament()
        {
            // Arrange
            TractamentController controller = new TractamentController(EDB);
            TestControllerBuilder builder = new TestControllerBuilder();
            builder.HttpContext.User = new FakePrincipal(new FakeIdentity("Metge"), new string[] { "Role" });//actualitzem User.Identity.Name
            builder.InitializeController(controller);
            Tractament model = new Tractament
            {
                ID_Tractament = 0,
                ID_Pacient = 1,
                DataInici = DateTime.Now,
                DataFi = DateTime.Now.AddDays(1),
                ID_Dosi =1,
                ID_Frequencia =1,
                ID_Medicament =1,
                ID_Usuari = 1
            };
            controller.HttpContext.Session["IDTipusEmpleat"] = 2;//Donem poders de creació de Tractaments

            //Creem una nova Tractament
            // Act
            var resultLogin = (RedirectToRouteResult)controller.Create(model);
            string consultaBD = "Select * from Tractament where ID_Tractament=" + model.ID_Tractament;
            SqlDataReader dr = Auxiliar.Auxiliar.findRecord(consultaBD);
            // Assert

            Assert.AreEqual("Index", resultLogin.RouteValues["action"]);//tormen a la pàgina principal de Tractaments

            //verifiquem que existeix el registre a la base de dades
            Assert.AreEqual(true, dr.HasRows);

            //Començem a eliminar

            resultLogin = (RedirectToRouteResult)controller.DeleteConfirmed(model.ID_Tractament);
            Assert.AreEqual("Index", resultLogin.RouteValues["action"]);//tormen a la pàgina principal de Tractaments

            //verifiquem que NO existeix el registre a la base de dades, que l'hem eliminat.
            dr = Auxiliar.Auxiliar.findRecord(consultaBD);
            Assert.AreEqual(false, dr.HasRows);

        }
    }
}
