﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.Mvc;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using GestioHospitalaria;
using GestioHospitalaria.Controllers;
using GestioHospitalaria.Tests;
using GestioHospitalaria.Tests.Models;
using GestioHospitalaria.Models;
using System.Web.Routing;
using System.Web;
using System.Security.Principal;
using GestioHospitalaria.Auxiliar;
using MvcContrib.TestHelper;
using System.Data.SqlClient;

namespace GestioHospitalaria.Integracio.Test.Tests
{
    [TestClass]
    public class Usuari_Test
    {
        EntityGestioHospitalariaManagerRepository EDB = new EntityGestioHospitalariaManagerRepository();

        //creem un nou usuari administrador
        [TestMethod]
        public void CreateUser()
        {
            // Arrange
            UsuariController controller = new UsuariController(EDB);
            TestControllerBuilder builder = new TestControllerBuilder();
            builder.InitializeController(controller);
            Usuari model = new Usuari
            {
                ID_Usuari = 0,
                NomUsuari = "ProvaTest001",
                Contrasenya = "ProvaTest001",
                ID_TipusEmpleat =1

            };
            controller.HttpContext.Session["IDTipusEmpleat"] = 1;//Donem poders de creació d'usuari
            //CREEM UN NOU USUARI
            // Act
            var resultLogin = (RedirectToRouteResult)controller.Create(model);
            string consultaBD = "Select * from Usuari where NomUsuari ='ProvaTest001' and Contrasenya = '" + Auxiliar.Auxiliar.EncodeMD5("ProvaTest001") + "'";
            SqlDataReader dr = Auxiliar.Auxiliar.findRecord(consultaBD);
            // Assert

            Assert.AreEqual("Index", resultLogin.RouteValues["action"]);//tormen a la pàgina principal d'usuaris

            //verifiquem que existeix el registre a la base de dades
            Assert.AreEqual(true, dr.HasRows);

        }
        [TestMethod]
        public void DeleteUser()
        {
            // Arrange
            UsuariController controller = new UsuariController(EDB);
            TestControllerBuilder builder = new TestControllerBuilder();
            builder.InitializeController(controller);
            //busquem l'usuari
            string consultaBD = "Select * from Usuari where NomUsuari ='ProvaTest001' and Contrasenya = '" + Auxiliar.Auxiliar.EncodeMD5("ProvaTest001") + "'";
            SqlDataReader dr = Auxiliar.Auxiliar.findRecord(consultaBD);

            controller.HttpContext.Session["IDTipusEmpleat"] = 1;//Donem poders de creació d'usuari
            //CREEM UN NOU USUARI
            // Act
            dr.Read();
            var resultLogin = (RedirectToRouteResult)controller.DeleteConfirmed(Convert.ToInt32(dr["ID_Usuari"].ToString()));

            // Assert

            Assert.AreEqual("Index", resultLogin.RouteValues["action"]);//tormen a la pàgina principal d'usuaris

            //verifiquem que NO existeix el registre a la base de dades, que l'hem eliminat.
            dr = Auxiliar.Auxiliar.findRecord(consultaBD);
            Assert.AreEqual(false, dr.HasRows);


        }

    }
}
