﻿using System;
using System.Text;
using System.Collections.Generic;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using GestioHospitalaria.Controllers;
using MvcContrib.TestHelper;
using GestioHospitalaria.Auxiliar;
using GestioHospitalaria.Models;
using GestioHospitalaria.Tests;
using System.Web.Mvc;

namespace GestioHospitalaria.Tests.Controllers
{
    /// <summary>
    /// Descripción resumida de AccountControllerTest
    /// </summary>
    [TestClass]
    public class AccountControllerTest
    {
        public AccountControllerTest()
        {
            //
            // TODO: Agregar aquí la lógica del constructor
            //
        }
        //Accedim com a Administrador
        [TestMethod]
        public void Acces_LoginAdminOK()
        {
            // Arrange
            AccountController controller = new AccountController();
            TestControllerBuilder builder = new TestControllerBuilder();
            builder.InitializeController(controller);
            AccountModel model = Auxiliar.Auxiliar.GetAccountModel();
            // Act
            var resultLogin = (RedirectToRouteResult)controller.Login(model);

            // Assert

            Assert.AreEqual("Logout", resultLogin.RouteValues["action"]);//surt per culpa FormsAuthentication.SetAuthCookie(model.UserName, model.RememberMe);
        }
        //Accedim com a Administrador però amb contrasenya canviada
        [TestMethod]
        public void Acces_LoginAdminNoOK()
        {
            // Arrange
            AccountController controller = new AccountController();
            TestControllerBuilder builder = new TestControllerBuilder();
            builder.InitializeController(controller);
            AccountModel model = Auxiliar.Auxiliar.GetAccountModelError();
            // Act
            var resultLogin = (ViewResult)controller.LoginSQL(model);

            // Assert

            Assert.AreEqual(null, resultLogin.ViewBag.Message);//tornem a la pàgina de login amb un error
        }
        //Sortim de l'aplicació
        [TestMethod]
        public void Logout_ExitError()
        {
            // Arrange
            AccountController controller = new AccountController();
            TestControllerBuilder builder = new TestControllerBuilder();
            builder.InitializeController(controller);
            //AccountModel model = Auxiliar.Auxiliar.GetAccountModelError();
            // Act
            var resultLogin = (RedirectToRouteResult)controller.Logout();

            // Assert

            Assert.AreEqual("Logout", resultLogin.RouteValues["action"]);//es produeix un error a cause de les variables de sessió
        }

    }
}
