﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.Mvc;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using GestioHospitalaria;
using GestioHospitalaria.Controllers;
using GestioHospitalaria.Tests;
using GestioHospitalaria.Tests.Models;
using GestioHospitalaria.Models;
using System.Web.Routing;
using System.Web;
using System.Security.Principal;
using System.Web.Hosting;
using System.Web.SessionState;
using System.IO;
using MvcContrib.TestHelper;
using Rhino.Mocks;

namespace GestioHospitalaria.Tests.Controllers
{
    [TestClass]
    public class HomeInfermeraControllerTest
    {

        [TestMethod]
        public void Index_Ask_For_UserSessionOK()
        {
            // Arrange
            HomeInfermeraController controller = new HomeInfermeraController(new InMemoryGestioHospitalariaRepository());
            TestControllerBuilder builder = new TestControllerBuilder();
            builder.InitializeController(controller);
            // Act
            controller.HttpContext.Session["IDTipusEmpleat"] = 3;
            ViewResult result = controller.Index() as ViewResult;

            // Assert
            Assert.AreEqual("Usuari OK", result.ViewBag.MessageOK);
        }
        [TestMethod]
        public void Index_Ask_For_UserSessionNoOK()
        {
            // Arrange
            HomeInfermeraController controller = new HomeInfermeraController(new InMemoryGestioHospitalariaRepository());
            TestControllerBuilder builder = new TestControllerBuilder();
            builder.InitializeController(controller);
            // Act
            controller.HttpContext.Session["IDTipusEmpleat"] = 2;
            var result = (RedirectToRouteResult)controller.Index();

            // Assert
            Assert.AreEqual("Logout", result.RouteValues["action"]);
        }


    }
}
