﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using GestioHospitalaria.Models;

namespace GestioHospitalaria.Tests.Models
{
    class InMemoryGestioHospitalariaRepository: IGestioHospitalariaRepository
    {
        private List<AdministrarFarmac> _AdministrarFarmac = new List<AdministrarFarmac>();
        private List<Dosi> _Dosi = new List<Dosi>();
        private List<EstatReserva> _EstatReserva = new List<EstatReserva>();
        private List<Frequencia> _Frequencia = new List<Frequencia>();
        private List<Habitacio> _Habitacio = new List<Habitacio>();
        private List<Ingres> _Ingres = new List<Ingres>();
        private List<Medicament> _Medicament = new List<Medicament>();
        private List<Ordre> _Ordre = new List<Ordre>();
        private List<Pacient> _Pacient = new List<Pacient>();
        private List<Quirofan> _Quirofan = new List<Quirofan>();
        private List<Reserva> _Reserva = new List<Reserva>();
        private List<TipusEmpleat> _TipusEmpleat = new List<TipusEmpleat>();
        private List<TipusOrdre> _TipusOrdre = new List<TipusOrdre>();
        private List<Tractament> _Tractament = new List<Tractament>();
        private List<Usuari> _Usuari = new List<Usuari>();
        
        public Exception ExceptionToThrow { get; set; }
        
        public int SaveChanges()
        {
            return 1;
        }

        //AdministrarFarmac
        public void SaveChangesAdministrarFarmac(AdministrarFarmac AdministrarFarmac)
        {
            
            foreach (AdministrarFarmac ad in _AdministrarFarmac)
            {
                if (ad.ID_AdministrarFarmac == AdministrarFarmac.ID_AdministrarFarmac)
                {
                    _AdministrarFarmac.Remove(ad);
                    _AdministrarFarmac.Add(AdministrarFarmac);
                    break;
                }   
            }
        }
        public void AddAdministrarFarmac(AdministrarFarmac AdministrarFarmac)
        {
            _AdministrarFarmac.Add(AdministrarFarmac);
        }
        public AdministrarFarmac GetAdministrarFarmacByID(int id)
        {
            return _AdministrarFarmac.FirstOrDefault(d => d.ID_AdministrarFarmac == id);
        }
        public void CreateNewAdministrarFarmac(AdministrarFarmac AdministrarFarmac)
        {
            if (ExceptionToThrow != null)
                throw ExceptionToThrow;

            _AdministrarFarmac.Add(AdministrarFarmac);

        }
        public IEnumerable<AdministrarFarmac> GetAllAdministrarFarmac()
        {
            return _AdministrarFarmac.ToList();
        }
        public void DeleteAdministrarFarmac(int id)
        {
            _AdministrarFarmac.Remove(GetAdministrarFarmacByID(id));
        }



        //Dosi
        public void SaveChangesDosi(Dosi Dosi)
        {

            foreach (Dosi dosi in _Dosi)
            {
                if (dosi.ID_Dosi == Dosi.ID_Dosi)
                {
                    _Dosi.Remove(dosi);
                    _Dosi.Add(Dosi);
                    break;
                }
            }
        }
        public void AddDosi(Dosi Dosi)
        {
            _Dosi.Add(Dosi);
        }
        public Dosi GetDosiByID(int id)
        {
            return _Dosi.FirstOrDefault(d => d.ID_Dosi == id);
        }
        public void CreateNewDosi(Dosi Dosi)
        {
            if (ExceptionToThrow != null)
                throw ExceptionToThrow;

            _Dosi.Add(Dosi);

        }
        public IEnumerable<Dosi> GetAllDosi()
        {
            return _Dosi.ToList();
        }
        public void DeleteDosi(int id)
        {
            _Dosi.Remove(GetDosiByID(id));
        }

        //EstatReserva
        public void SaveChangesEstatReserva(EstatReserva EstatReserva)
        {

            foreach (EstatReserva estat in _EstatReserva)
            {
                if (estat.ID_EstatReserva == EstatReserva.ID_EstatReserva)
                {
                    _EstatReserva.Remove(estat);
                    _EstatReserva.Add(EstatReserva);
                    break;
                }
            }
        }
        public void AddEstatReserva(EstatReserva EstatReserva)
        {
            _EstatReserva.Add(EstatReserva);
        }
        public EstatReserva GetEstatReservaByID(int id)
        {
            return _EstatReserva.FirstOrDefault(d => d.ID_EstatReserva == id);
        }
        public void CreateNewEstatReserva(EstatReserva EstatReserva)
        {
            if (ExceptionToThrow != null)
                throw ExceptionToThrow;

            _EstatReserva.Add(EstatReserva);

        }
        public IEnumerable<EstatReserva> GetAllEstatReserva()
        {
            return _EstatReserva.ToList();
        }
        public void DeleteEstatReserva(int id)
        {
            _EstatReserva.Remove(GetEstatReservaByID(id));
        }

        //Frequencia
        public void SaveChangesFrequencia(Frequencia Frequencia)
        {

            foreach (Frequencia var in _Frequencia)
            {
                if (var.ID_Frequencia == Frequencia.ID_Frequencia)
                {
                    _Frequencia.Remove(var);
                    _Frequencia.Add(Frequencia);
                    break;
                }
            }
        }
        public void AddFrequencia(Frequencia Frequencia)
        {
            _Frequencia.Add(Frequencia);
        }
        public Frequencia GetFrequenciaByID(int id)
        {
            return _Frequencia.FirstOrDefault(d => d.ID_Frequencia == id);
        }
        public void CreateNewFrequencia(Frequencia Frequencia)
        {
            if (ExceptionToThrow != null)
                throw ExceptionToThrow;

            _Frequencia.Add(Frequencia);

        }
        public IEnumerable<Frequencia> GetAllFrequencia()
        {
            return _Frequencia.ToList();
        }
        public void DeleteFrequencia(int id)
        {
            _Frequencia.Remove(GetFrequenciaByID(id));
        }

        //Habitacio
        public void SaveChangesHabitacio(Habitacio Habitacio)
        {

            foreach (Habitacio var in _Habitacio)
            {
                if (var.ID_Habitacio == Habitacio.ID_Habitacio)
                {
                    _Habitacio.Remove(var);
                    _Habitacio.Add(Habitacio);
                    break;
                }
            }
        }
        public void AddHabitacio(Habitacio Habitacio)
        {
            _Habitacio.Add(Habitacio);
        }
        public Habitacio GetHabitacioByID(int id)
        {
            return _Habitacio.FirstOrDefault(d => d.ID_Habitacio == id);
        }
        public void CreateNewHabitacio(Habitacio Habitacio)
        {
            if (ExceptionToThrow != null)
                throw ExceptionToThrow;

            _Habitacio.Add(Habitacio);

        }
        public IEnumerable<Habitacio> GetAllHabitacio()
        {
            return _Habitacio.ToList();
        }
        public void DeleteHabitacio(int id)
        {
            _Habitacio.Remove(GetHabitacioByID(id));
        }

        //Ingres
        public void SaveChangesIngres(Ingres Ingres)
        {

            foreach (Ingres var in _Ingres)
            {
                if (var.ID_Ingres == Ingres.ID_Ingres)
                {
                    _Ingres.Remove(var);
                    _Ingres.Add(Ingres);
                    break;
                }
            }
        }
        public void AddIngres(Ingres Ingres)
        {
            _Ingres.Add(Ingres);
        }
        public Ingres GetIngresByID(int id)
        {
            return _Ingres.FirstOrDefault(d => d.ID_Ingres == id);
        }
        public void CreateNewIngres(Ingres Ingres)
        {
            if (ExceptionToThrow != null)
                throw ExceptionToThrow;

            _Ingres.Add(Ingres);

        }
        public IEnumerable<Ingres> GetAllIngres()
        {
            return _Ingres.ToList();
        }
        public void DeleteIngres(int id)
        {
            _Ingres.Remove(GetIngresByID(id));
        }

        //Medicament
        public void SaveChangesMedicament(Medicament Medicament)
        {

            foreach (Medicament var in _Medicament)
            {
                if (var.ID_Medicament == Medicament.ID_Medicament)
                {
                    _Medicament.Remove(var);
                    _Medicament.Add(Medicament);
                    break;
                }
            }
        }
        public void AddMedicament(Medicament Medicament)
        {
            _Medicament.Add(Medicament);
        }
        public Medicament GetMedicamentByID(int id)
        {
            return _Medicament.FirstOrDefault(d => d.ID_Medicament == id);
        }
        public void CreateNewMedicament(Medicament Medicament)
        {
            if (ExceptionToThrow != null)
                throw ExceptionToThrow;

            _Medicament.Add(Medicament);

        }
        public IEnumerable<Medicament> GetAllMedicament()
        {
            return _Medicament.ToList();
        }
        public void DeleteMedicament(int id)
        {
            _Medicament.Remove(GetMedicamentByID(id));
        }

        //Ordre
        public void SaveChangesOrdre(Ordre Ordre)
        {

            foreach (Ordre var in _Ordre)
            {
                if (var.ID_Ordre == Ordre.ID_Ordre)
                {
                    _Ordre.Remove(var);
                    _Ordre.Add(Ordre);
                    break;
                }
            }
        }
        public void AddOrdre(Ordre Ordre)
        {
            _Ordre.Add(Ordre);
        }
        public Ordre GetOrdreByID(int id)
        {
            return _Ordre.FirstOrDefault(d => d.ID_Ordre == id);
        }
        public void CreateNewOrdre(Ordre Ordre)
        {
            if (ExceptionToThrow != null)
                throw ExceptionToThrow;

            _Ordre.Add(Ordre);

        }
        public IEnumerable<Ordre> GetAllOrdre()
        {
            return _Ordre.ToList();
        }
        public void DeleteOrdre(int id)
        {
            _Ordre.Remove(GetOrdreByID(id));
        }

        //Pacient
        public void SaveChangesPacient(Pacient Pacient)
        {

            foreach (Pacient var in _Pacient)
            {
                if (var.ID_Pacient == Pacient.ID_Pacient)
                {
                    _Pacient.Remove(var);
                    _Pacient.Add(Pacient);
                    break;
                }
            }
        }
        public void AddPacient(Pacient Pacient)
        {
            _Pacient.Add(Pacient);
        }
        public Pacient GetPacientByID(int id)
        {
            return _Pacient.FirstOrDefault(d => d.ID_Pacient == id);
        }
        public void CreateNewPacient(Pacient Pacient)
        {
            if (ExceptionToThrow != null)
                throw ExceptionToThrow;

            _Pacient.Add(Pacient);

        }
        public IEnumerable<Pacient> GetAllPacient()
        {
            return _Pacient.ToList();
        }
        public void DeletePacient(int id)
        {
            _Pacient.Remove(GetPacientByID(id));
        }

        //Quirofan
        public void SaveChangesQuirofan(Quirofan Quirofan)
        {

            foreach (Quirofan var in _Quirofan)
            {
                if (var.ID_Quirofan == Quirofan.ID_Quirofan)
                {
                    _Quirofan.Remove(var);
                    _Quirofan.Add(Quirofan);
                    break;
                }
            }
        }
        public void AddQuirofan(Quirofan Quirofan)
        {
            _Quirofan.Add(Quirofan);
        }
        public Quirofan GetQuirofanByID(int id)
        {
            return _Quirofan.FirstOrDefault(d => d.ID_Quirofan == id);
        }
        public void CreateNewQuirofan(Quirofan Quirofan)
        {
            if (ExceptionToThrow != null)
                throw ExceptionToThrow;

            _Quirofan.Add(Quirofan);

        }
        public IEnumerable<Quirofan> GetAllQuirofan()
        {
            return _Quirofan.ToList();
        }
        public void DeleteQuirofan(int id)
        {
            _Quirofan.Remove(GetQuirofanByID(id));
        }

        //Reserva
        public void SaveChangesReserva(Reserva Reserva)
        {

            foreach (Reserva var in _Reserva)
            {
                if (var.ID_Reserva == Reserva.ID_Reserva)
                {
                    _Reserva.Remove(var);
                    _Reserva.Add(Reserva);
                    break;
                }
            }
        }
        public void AddReserva(Reserva Reserva)
        {
            _Reserva.Add(Reserva);
        }
        public Reserva GetReservaByID(int id)
        {
            return _Reserva.FirstOrDefault(d => d.ID_Reserva == id);
        }
        public void CreateNewReserva(Reserva Reserva)
        {
            if (ExceptionToThrow != null)
                throw ExceptionToThrow;

            _Reserva.Add(Reserva);

        }
        public IEnumerable<Reserva> GetAllReserva()
        {
            return _Reserva.ToList();
        }
        public void DeleteReserva(int id)
        {
            _Reserva.Remove(GetReservaByID(id));
        }

        //TipusEmpleat
        public void SaveChangesTipusEmpleat(TipusEmpleat TipusEmpleat)
        {

            foreach (TipusEmpleat var in _TipusEmpleat)
            {
                if (var.ID_TipusEmpleat == TipusEmpleat.ID_TipusEmpleat)
                {
                    _TipusEmpleat.Remove(var);
                    _TipusEmpleat.Add(TipusEmpleat);
                    break;
                }
            }
        }
        public void AddTipusEmpleat(TipusEmpleat TipusEmpleat)
        {
            _TipusEmpleat.Add(TipusEmpleat);
        }
        public TipusEmpleat GetTipusEmpleatByID(int id)
        {
            return _TipusEmpleat.FirstOrDefault(d => d.ID_TipusEmpleat == id);
        }
        public void CreateNewTipusEmpleat(TipusEmpleat TipusEmpleat)
        {
            if (ExceptionToThrow != null)
                throw ExceptionToThrow;

            _TipusEmpleat.Add(TipusEmpleat);

        }
        public IEnumerable<TipusEmpleat> GetAllTipusEmpleat()
        {
            return _TipusEmpleat.ToList();
        }
        public void DeleteTipusEmpleat(int id)
        {
            _TipusEmpleat.Remove(GetTipusEmpleatByID(id));
        }

        //TipusOrdre
        public void SaveChangesTipusOrdre(TipusOrdre TipusOrdre)
        {

            foreach (TipusOrdre var in _TipusOrdre)
            {
                if (var.ID_TipusOrdre == TipusOrdre.ID_TipusOrdre)
                {
                    _TipusOrdre.Remove(var);
                    _TipusOrdre.Add(TipusOrdre);
                    break;
                }
            }
        }
        public void AddTipusOrdre(TipusOrdre TipusOrdre)
        {
            _TipusOrdre.Add(TipusOrdre);
        }
        public TipusOrdre GetTipusOrdreByID(int id)
        {
            return _TipusOrdre.FirstOrDefault(d => d.ID_TipusOrdre == id);
        }
        public void CreateNewTipusOrdre(TipusOrdre TipusOrdre)
        {
            if (ExceptionToThrow != null)
                throw ExceptionToThrow;

            _TipusOrdre.Add(TipusOrdre);

        }
        public IEnumerable<TipusOrdre> GetAllTipusOrdre()
        {
            return _TipusOrdre.ToList();
        }
        public void DeleteTipusOrdre(int id)
        {
            _TipusOrdre.Remove(GetTipusOrdreByID(id));
        }

        //Tractament
        public void SaveChangesTractament(Tractament Tractament)
        {

            foreach (Tractament var in _Tractament)
            {
                if (var.ID_Tractament == Tractament.ID_Tractament)
                {
                    _Tractament.Remove(var);
                    _Tractament.Add(Tractament);
                    break;
                }
            }
        }
        public void AddTractament(Tractament Tractament)
        {
            _Tractament.Add(Tractament);
        }
        public Tractament GetTractamentByID(int id)
        {
            return _Tractament.FirstOrDefault(d => d.ID_Tractament == id);
        }
        public void CreateNewTractament(Tractament Tractament)
        {
            if (ExceptionToThrow != null)
                throw ExceptionToThrow;

            _Tractament.Add(Tractament);

        }
        public IEnumerable<Tractament> GetAllTractament()
        {
            return _Tractament.ToList();
        }
        public void DeleteTractament(int id)
        {
            _Tractament.Remove(GetTractamentByID(id));
        }

        //Usuari
        public void SaveChangesUsuari(Usuari Usuari)
        {

            foreach (Usuari var in _Usuari)
            {
                if (var.ID_Usuari == Usuari.ID_Usuari)
                {
                    _Usuari.Remove(var);
                    _Usuari.Add(Usuari);
                    break;
                }
            }
        }
        public void AddUsuari(Usuari Usuari)
        {
            _Usuari.Add(Usuari);
        }
        public Usuari GetUsuariByID(int id)
        {
            return _Usuari.FirstOrDefault(d => d.ID_Usuari == id);
        }
        public void CreateNewUsuari(Usuari Usuari)
        {
            if (ExceptionToThrow != null)
                throw ExceptionToThrow;

            _Usuari.Add(Usuari);

        }
        public IEnumerable<Usuari> GetAllUsuari()
        {
            return _Usuari.ToList();
        }
        public void DeleteUsuari(int id)
        {
            _Usuari.Remove(GetUsuariByID(id));
        }

    }
}
