﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.Web;
using System.Web.Mvc;
using GestioHospitalaria.Models;
using System.Data;
using System.Data.Entity;
using System.Data.SqlClient;



namespace GestioHospitalaria.Auxiliar
{

    //classe que aporta un conjunt de funcionalitatats extras per fer servir a l'aplicació
    public class Auxiliar
    {


        //Validar un NIF

        public static Boolean VerificarNIF(String valor)
        {
            String aux = null;
            valor = valor.ToUpper();

            aux = valor.Substring(0, valor.Length - 1);
            long number1 = 0;
            if (aux.Length >= 7 && long.TryParse(aux, out number1))
                    aux = CalculaNIF(number1); 
            else
                return false;

            return (valor == aux);
        }

        //Obtenir la lletra
        private static String CalculaNIF(long number)
        {
            const String cCADENA = "TRWAGMYFPDXBNJZSQVHLCKE";
            int calculate = Convert.ToInt32(number % 23);

            return number.ToString() + cCADENA.Substring(calculate, 1);
        }
        
        public static string EncodeMD5(string cadena)
        {
            //Declaracions
            Byte[] originalBytes;
            Byte[] encodedBytes;
            MD5 md5;

            //transformen la cadena rebuda en un conjunt de bytes codificats amb l'algoritme MD5
            md5 = new MD5CryptoServiceProvider();
            originalBytes = ASCIIEncoding.Default.GetBytes(cadena);
            encodedBytes = md5.ComputeHash(originalBytes);

            //Eliminem els guions de la cadena codificada
            return BitConverter.ToString(encodedBytes).Replace("-", "");
        }
        
        /*
         * 
         * Verifiquem que te autorització per entrar (tipus d'usuari correcte)
         * 
         */
        
        public static bool is_Authorized(HttpSessionStateBase Session, string TipusUsuariNecessari)
        {
            string tipusUsuari;

            if (Session["IDTipusEmpleat"] != null)
            {
                tipusUsuari = Session["IDTipusEmpleat"].ToString();
            }
            else
            {
                tipusUsuari = "";
            }
            if (tipusUsuari == TipusUsuariNecessari)
            {
                return true;
            }
            else
            {
                return false;
            }

        }


        public static string setDireccio(HttpSessionStateBase Session)
        {
            string direccio;

            if (Session["Direccio"] != null)
            {
                direccio = Session["Direccio"].ToString();
            }
            else
            {
                direccio = "";
            }
            return direccio;

        }

        public static SqlDataReader findRecord(string consultaSql)
        {
            //consulta genèrica....
            string st = System.Configuration.ConfigurationManager.ConnectionStrings["BD_GestioHospitalaria"].ConnectionString;
            SqlConnection cn = new SqlConnection(System.Configuration.ConfigurationManager.ConnectionStrings["BD_GestioHospitalaria"].ConnectionString);
            cn.Open();
            SqlCommand cmd = new SqlCommand(consultaSql, cn);
            SqlDataReader dr = cmd.ExecuteReader();
            return dr;

        }
        public static AdministrarFarmac GetAdministrarFarmacID_1()
        {
            return GetAdministrarFarmacF(1);

        }
        public static Dosi GetDosiID_1()
        {
            return GetDosiF(1);
        }

        public static EstatReserva GetEstatReservaID_1()
        {
            return GetEstatReservaF(1);
        }
        public static Frequencia GetFrequenciaID_1()
        {
            return GetFrequenciaF(1);
        }
        public static Habitacio GetHabitacioID_1()
        {
            return GetHabitacioF(1);
        }
        public static Medicament GetMedicamentID_1()
        {
            return GetMedicamentF(1);
        }
        public static Pacient GetPacientID_1()
        {
            return GetPacientF(1);
        }
        public static Quirofan GetQuirofanID_1()
        {
            return GetQuirofanF(1);
        }
        public static Reserva GetReservaID_1()
        {
            return GetReservaF(1);
        }
        public static TipusEmpleat GetTipusEmpleatID_1()
        {
            return GetTipusEmpleatF(1);
        }
        public static TipusOrdre GetTipusOrdreID_1()
        {
            return GetTipusOrdreF(1);
        }
        public static Tractament GetTractamentID_1()
        {
            return GetTractamentF(1);
        }
        public static Usuari GetUsuariID_1()
        {
            return GetUsuariF(1);
        }
        public static Ingres GetIngresID_1()
        {
            return GetIngresF(1);
        }
        public static Ordre GetOrdreID_1()
        {
            return GetOrdreF(1);
        }
        public static AdministrarFarmac GetAdministrarFarmacF(int id)
        {
            return new AdministrarFarmac
            {
                ID_AdministrarFarmac = id,
                ID_Dosi = 1,
                ID_Habitacio = 1,
                ID_Medicament = 1,
                ID_Usuari = 1,
                DataHora = DateTime.Now,
                Dosi = GetDosiF(1),
                Habitacio = GetHabitacioF(1),
                Medicament = GetMedicamentF(1),
                Usuari = GetUsuariF(1)
            };

        }
        public static Dosi GetDosiF(int id)
        {
            return new Dosi
            {
                ID_Dosi = id,
                Unitat = "cm3",
                Valor = 1,
            };

        }
        public static Quirofan GetQuirofanF(int id)
        {
            return new Quirofan
            {
                ID_Quirofan = id,
                Descripcio ="Quiròfan 1"
            };

        }
        public static Habitacio GetHabitacioF(int id)
        {
            return new Habitacio
            {
                ID_Habitacio = id,
                Descripcio = "Habitació 1-1"
            };

        }
        public static EstatReserva GetEstatReservaF(int id)
        {
            return new EstatReserva
            {
                ID_EstatReserva = 1,
                Descripcio = "Reservat"
            };


        }
        public static Reserva GetReservaF(int id)
        {
            return new Reserva
            {
                ID_Reserva = 1,
                ID_EstatReserva = 1,
                ID_Ordre = 1,
                ID_Quirofan =1,
                ID_Usuari = 1,
                DataHoraInici = DateTime.Now,
                DataHoraFi = DateTime.Now.AddDays(1),
                Usuari = GetUsuariF(1),
                Ordre = GetOrdreF(1),
                Quirofan= GetQuirofanF(1),
                EstatReserva= GetEstatReservaF(1)
            };


        }

        public static TipusEmpleat GetTipusEmpleatF(int id)
        {
            return new TipusEmpleat
            {
                ID_TipusEmpleat = 1,
                Descripcio = "Admin"
            };


        }
        public static TipusOrdre GetTipusOrdreF(int id)
        {
            return new TipusOrdre
            {
                ID_TipusOrdre = 1,
                Descripcio = "Hospitalitzacio"
            };


        }
        public static Ingres GetIngresF(int id)
        {
            return new Ingres
            {
                ID_Ingres = 1,
                ID_Habitacio = 1,
                ID_Ordre=1,
                ID_Usuari=1,
                DataInici = DateTime.Now,
                DataFi = DateTime.Now.AddDays(1),
                Habitacio = GetHabitacioF(1),
                Usuari = GetUsuariF(1),
                Ordre = GetOrdreF(1)
            };


        }

        public static Tractament GetTractamentF(int id)
        {
            return new Tractament
            {
                ID_Tractament=1,
                ID_Dosi=1,
                ID_Frequencia=1,
                ID_Medicament=1,
                DataInici = DateTime.Now,
                DataFi = DateTime.Now.AddDays(1),
                ID_Usuari = 1,
                Pacient = GetPacientF(1),
                Usuari = GetUsuariF(1),
                ID_Pacient=1,
                Dosi= GetDosiF(1),
                Frequencia= GetFrequenciaF(1),
                Medicament = GetMedicamentF(1)
                
            };


        }

        public static Ordre GetOrdreF(int id)
        {
            return new Ordre
            {
                ID_Ordre = 1,
                DataHoraInici = DateTime.Now,
                Durada = 24,
                ID_Pacient =1,
                ID_TipusOrdre =1,
                ID_Usuari =1,
                Pacient = GetPacientF(1),
                TipusOrdre = GetTipusOrdreF(1)
            };


        }
        public static Frequencia GetFrequenciaF(int id)
        {
            return new Frequencia
            {
                ID_Frequencia = 1,
                Descripcio = "Cada 8 hores",
                Dies =0,
                Hores = 8,
                Mesos = 0,
                Minuts =0,
                Setmanes =0
            };


        }
        public static Medicament GetMedicamentF(int id)
        {
            return new Medicament
            {
                ID_Medicament = id,
                Descripcio = "Aspirina",
            };

        }
        public static Usuari GetUsuariF(int id)
        {
            return new Usuari
            {
                ID_Usuari = id,
                NomUsuari = "Admin",
                Contrasenya = "Admin",
                ID_TipusEmpleat =1

            };

        }
        public static Pacient GetPacientF(int id)
        {
            return new Pacient
            {
                ID_Pacient = id,
                Nom = "Rafa1",
                Targeta="AAA000"

            };

        }
        public static AccountModel GetAccountModel()
        {
            return new AccountModel
            {
                UserName = "Administrador",
                Password = "Administrador",
                RememberMe = false

            };
        }
        public static AccountModel GetAccountModelError()
        {
            return new AccountModel
            {
                UserName = "Administrador",
                Password = "Admin",
                RememberMe = false

            };
        }

        public static ModificarContrasenyaModel GetModificarContrasenyaModel()
        {
            return new ModificarContrasenyaModel
            {
                UserName = "Administrador",
                AntigaContraseny = "Administrador",
                NovaContraseny ="Administrador1",
                ConfNovaContraseny ="Administrador1"
            };
        }
        public static ModificarContrasenyaModel GetModificarContrasenyaModelError()
        {
            return new ModificarContrasenyaModel
            {
                UserName = "Administrador",
                AntigaContraseny = "Administrador",
                NovaContraseny = "Administrador2",
                ConfNovaContraseny = "Administrador1"
            };
        }
    }
}