﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Security;
using GestioHospitalaria.Models;

namespace GestioHospitalaria.Controllers
{
    public class AccountController : Controller
    {
        //
        // GET: /Account/
        [HttpGet]
        public ActionResult Login()
        {
            return View();
        }
        [HttpPost]
        public ActionResult Login(AccountModel model)
        {
            try
            {
                if (ModelState.IsValid)
                {
                    Usuari usuari = new Usuari();
                    //usuari = model.IsValid(model.UserName, model.Password);//consulta directa SQL
                    usuari = model.IsValidEntity(model.UserName, model.Password);//sense consulta directa SQL fent servir Entity FrameWork

                    if (usuari != null)
                    {
                        //variables de sessió que emmagatzema l'id d'usuari i el tipus d'ususari
                        Session["IDUsuari"] = usuari.ID_Usuari;
                        Session["IDTipusEmpleat"] = usuari.ID_TipusEmpleat;
                        switch (usuari.ID_TipusEmpleat)//direccionem a cada usuari en funció del seu Rol
                        {


                            //segons el tipus d'usuari redirigim a la pàgina que li correspon
                            case 1:
                                FormsAuthentication.SetAuthCookie(model.UserName, model.RememberMe);
                                return RedirectToAction("Index", "HomeAdministrador", usuari);
                            case 2:
                                FormsAuthentication.SetAuthCookie(model.UserName, model.RememberMe);
                                return RedirectToAction("Index", "HomeMetge", usuari);
                            case 3:
                                FormsAuthentication.SetAuthCookie(model.UserName, model.RememberMe);
                                return RedirectToAction("Index", "HomeInfermera", usuari);
                            case 4:
                                FormsAuthentication.SetAuthCookie(model.UserName, model.RememberMe);
                                return RedirectToAction("Index", "HomeRecepcionista", usuari);

                            default:
                                ModelState.AddModelError("", "El nom d'usuari o la contrasenya facilitada no és correcte.");
                                break;

                        }
                    }
                    else
                    {
                        ModelState.AddModelError("", "El nom d'usuari o la contrasenya facilitada no és correcte.");

                    }
                }
                return View(model);
            }
            catch (Exception ex)
            {
                ViewBag.Message = "Error no controlat";
                Session["ErrorMes"] = ex.Message;
                return RedirectToAction("Logout", "Account");
            }
        }
        public ActionResult Logout()
        {
            try
            {
                FormsAuthentication.SignOut();
                Session.Abandon();
                return RedirectToAction("Index", "Home");
            }
            catch (Exception ex)
            {
                ViewBag.Message = "Error no controlat";
                Session["ErrorMes"] = ex.Message;
                return RedirectToAction("Logout", "Account");
            }
        }
        [HttpPost]
        public ActionResult LoginSQL(AccountModel model)
        {
            try
            {
                if (ModelState.IsValid)
                {
                    Usuari usuari = new Usuari();
                    usuari = model.IsValid(model.UserName, model.Password);//consulta directa SQL
                    //usuari = model.IsValidEntity(model.UserName, model.Password);//sense consulta directa SQL fent servir Entity FrameWork

                    if (usuari != null)
                    {
                        //variables de sessió que emmagatzema l'id d'usuari i el tipus d'ususari
                        Session["IDUsuari"] = usuari.ID_Usuari;
                        Session["IDTipusEmpleat"] = usuari.ID_TipusEmpleat;
                        switch (usuari.ID_TipusEmpleat)//direccionem a cada usuari en funció del seu Rol
                        {


                            //segons el tipus d'usuari redirigim a la pàgina que li correspon
                            case 1:
                                FormsAuthentication.SetAuthCookie(model.UserName, model.RememberMe);
                                return RedirectToAction("Index", "HomeAdministrador", usuari);
                            case 2:
                                FormsAuthentication.SetAuthCookie(model.UserName, model.RememberMe);
                                return RedirectToAction("Index", "HomeMetge", usuari);
                            case 3:
                                FormsAuthentication.SetAuthCookie(model.UserName, model.RememberMe);
                                return RedirectToAction("Index", "HomeInfermera", usuari);
                            case 4:
                                FormsAuthentication.SetAuthCookie(model.UserName, model.RememberMe);
                                return RedirectToAction("Index", "HomeRecepcionista", usuari);

                            default:
                                ModelState.AddModelError("", "El nom d'usuari o la contrasenya facilitada no és correcte.");
                                break;

                        }
                    }
                    else
                    {
                        ModelState.AddModelError("", "El nom d'usuari o la contrasenya facilitada no és correcte.");

                    }
                }
                return View(model);
            }
            catch (Exception ex)
            {
                ViewBag.Message = "Error no controlat";
                Session["ErrorMes"] = ex.Message;
                return RedirectToAction("Logout", "Account");
            }
        }

    }
}
