﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Security;
using GestioHospitalaria.Models;
using GestioHospitalaria.Auxiliar;

namespace GestioHospitalaria.Controllers
{
    public class ModificarContrasenyaController : Controller
    {
        //
        // GET: /ModificarContrasenya/

        [HttpGet]
        public ActionResult Index()
        {
            try
            {
                return View();
            }
            catch (Exception ex)
            {
                ViewBag.Message = "Error no controlat";
                Session["ErrorMes"] = ex.Message;
                return RedirectToAction("Logout", "Account");
            }
        }
        [HttpPost]
        public ActionResult Index(ModificarContrasenyaModel model, bool test =false)
        {
            try
            {
                if (model.NovaContraseny != null && model.ConfNovaContraseny != null && model.AntigaContraseny != null && model.UserName != null)
                {
                    if (model.NovaContraseny == model.AntigaContraseny)
                    {
                        ModelState.AddModelError("", "La contrasenya nova no pot ser igual a la antiga");
                    }
                    else
                    {
                        Usuari usuari = new Usuari();
                        //usuari = model.IsValid(model.NovaContraseny, model.ConfNovaContraseny, model.AntigaContraseny, model.UserName, test);//consulta directa SQL
                        usuari = model.IsValidEntity(model.NovaContraseny, model.ConfNovaContraseny, model.AntigaContraseny, model.UserName, test);//sense consulta directa SQL fent servir Entity FrameWork

                        if (usuari != null)
                        {

                            switch (usuari.ID_TipusEmpleat)//direccionem a cada usuari en funció del seu Rol (funció futura)
                            {

                                case 1:
                                    return RedirectToAction("Index", "ContrasenyaCanviada");
                                case 2:
                                    return RedirectToAction("Index", "ContrasenyaCanviada");
                                case 3:
                                    return RedirectToAction("Index", "ContrasenyaCanviada");
                                case 4:
                                    return RedirectToAction("Index", "ContrasenyaCanviada");
                                default:
                                    return RedirectToAction("Index", "ContrasenyaCanviada");
                            }
                        }
                        else
                        {
                            if (model.ConfNovaContraseny != model.NovaContraseny)
                            {
                                ModelState.AddModelError("", "No coincideixen les contrasenyes");

                            }
                            else
                                ModelState.AddModelError("", "El nom d'usuari o la contrasenya facilitada no és correcte.");

                        }
                    }
                }
                else
                {
                    ModelState.AddModelError("", "Has deixat camps buïts");

                }

                return View(model);
            }
            catch (Exception ex)
            {
                ViewBag.Message = "Error no controlat";
                Session["ErrorMes"] = ex.Message;
                return RedirectToAction("Logout", "Account");
            }
        }
        [HttpPost]
        public ActionResult IndexSQL(ModificarContrasenyaModel model, bool test = false)
        {
            try
            {
                if (model.NovaContraseny != null && model.ConfNovaContraseny != null && model.AntigaContraseny != null && model.UserName != null)
                {
                    if (model.NovaContraseny == model.AntigaContraseny)
                    {
                        ModelState.AddModelError("", "La contrasenya nova no pot ser igual a la antiga");
                    }
                    else
                    {
                        Usuari usuari = new Usuari();
                        usuari = model.IsValid(model.NovaContraseny, model.ConfNovaContraseny, model.AntigaContraseny, model.UserName, test);//consulta directa SQL
                        //usuari = model.IsValidEntity(model.NovaContraseny, model.ConfNovaContraseny, model.AntigaContraseny, model.UserName, test);//sense consulta directa SQL fent servir Entity FrameWork

                        if (usuari != null)
                        {

                            switch (usuari.ID_TipusEmpleat)//direccionem a cada usuari en funció del seu Rol (funció futura)
                            {

                                case 1:
                                    return RedirectToAction("Index", "ContrasenyaCanviada");
                                case 2:
                                    return RedirectToAction("Index", "ContrasenyaCanviada");
                                case 3:
                                    return RedirectToAction("Index", "ContrasenyaCanviada");
                                case 4:
                                    return RedirectToAction("Index", "ContrasenyaCanviada");
                                default:
                                    return RedirectToAction("Index", "ContrasenyaCanviada");
                            }
                        }
                        else
                        {
                            if (model.ConfNovaContraseny != model.NovaContraseny)
                            {
                                ModelState.AddModelError("", "No coincideixen les contrasenyes");

                            }
                            else
                                ModelState.AddModelError("", "El nom d'usuari o la contrasenya facilitada no és correcte.");

                        }
                    }
                }
                else
                {
                    ModelState.AddModelError("", "Has deixat camps buïts");

                }

                return View(model);
            }
            catch (Exception ex)
            {
                ViewBag.Message = "Error no controlat";
                Session["ErrorMes"] = ex.Message;
                return RedirectToAction("Logout", "Account");
            }
        }
    }
}
