﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace GestioHospitalaria.Models
{
    public class EntityGestioHospitalariaManagerRepository : IGestioHospitalariaRepository
    {
        private BD_GestioHospitalariaEntities _db = new BD_GestioHospitalariaEntities();

        //OBTENIM EL CONJUNT DE LA BASE DE DADES
        public BD_GestioHospitalariaEntities getDB()
        {
            return _db;
        }
        //AdministrarFarmac
        public void CreateNewAdministrarFarmac(AdministrarFarmac administrarFarmac){
            _db.AdministrarFarmac.Add(administrarFarmac);
            _db.SaveChanges();

        }
        public void DeleteAdministrarFarmac(int id){
            var conToDel = GetAdministrarFarmacByID(id);
            _db.AdministrarFarmac.Remove(conToDel);
            _db.SaveChanges();

        }
        public AdministrarFarmac GetAdministrarFarmacByID(int id){
            return _db.AdministrarFarmac.FirstOrDefault(d => d.ID_AdministrarFarmac == id);
        }
        public IEnumerable<AdministrarFarmac> GetAllAdministrarFarmac(){
            return _db.AdministrarFarmac.ToList();

        }

        //Dosi
        public void CreateNewDosi(Dosi dosi)
        {
            _db.Dosi.Add(dosi);
            _db.SaveChanges();
        }
        public void DeleteDosi(int id)
        {
            var conToDel = GetDosiByID(id);
            _db.Dosi.Remove(conToDel);
            _db.SaveChanges();

        }
        public Dosi GetDosiByID(int id)
        {
            return _db.Dosi.FirstOrDefault(d => d.ID_Dosi == id);
        }
        public IEnumerable<Dosi> GetAllDosi()
        {
            return _db.Dosi.ToList();
        }

        //EstatReserva
        public void CreateNewEstatReserva(EstatReserva estatReserva)
        {
            _db.EstatReserva.Add(estatReserva);
            _db.SaveChanges();

        }
        public void DeleteEstatReserva(int id)
        {
            var conToDel = GetEstatReservaByID(id);
            _db.EstatReserva.Remove(conToDel);
            _db.SaveChanges();
        }
        public EstatReserva GetEstatReservaByID(int id)
        {
            return _db.EstatReserva.FirstOrDefault(d => d.ID_EstatReserva == id);

        }
        public IEnumerable<EstatReserva> GetAllEstatReserva()
        {
            return _db.EstatReserva.ToList();
        }

        //Frequencia
        public void CreateNewFrequencia(Frequencia frequencia)
        {
            _db.Frequencia.Add(frequencia);
            _db.SaveChanges();
        }
        public void DeleteFrequencia(int id)
        {
            var conToDel = GetFrequenciaByID(id);
            _db.Frequencia.Remove(conToDel);
            _db.SaveChanges();

        }
        public Frequencia GetFrequenciaByID(int id)
        {
            return _db.Frequencia.FirstOrDefault(d => d.ID_Frequencia == id);
        }
        public IEnumerable<Frequencia> GetAllFrequencia()
        {
            return _db.Frequencia.ToList();
        }

        //Habitacio
        public void CreateNewHabitacio(Habitacio habitacio)
        {
            _db.Habitacio.Add(habitacio);
            _db.SaveChanges();
        }
        public void DeleteHabitacio(int id)
        {
            var conToDel = GetHabitacioByID(id);
            _db.Habitacio.Remove(conToDel);
            _db.SaveChanges();

        }
        public Habitacio GetHabitacioByID(int id)
        {
            return _db.Habitacio.FirstOrDefault(d => d.ID_Habitacio == id);
        }
        public IEnumerable<Habitacio> GetAllHabitacio()
        {
            return _db.Habitacio.ToList();
        }

        //Ingres
        public void CreateNewIngres(Ingres ingres)
        {
            _db.Ingres.Add(ingres);
            _db.SaveChanges();
        }
        public void DeleteIngres(int id)
        {
            var conToDel = GetIngresByID(id);
            _db.Ingres.Remove(conToDel);
            _db.SaveChanges();
        }
        public Ingres GetIngresByID(int id)
        {
            return _db.Ingres.FirstOrDefault(d => d.ID_Ingres == id);

        }
        public IEnumerable<Ingres> GetAllIngres()
        {
            return _db.Ingres.ToList();
        }

        //Medicament
        public void CreateNewMedicament(Medicament medicament)
        {
            _db.Medicament.Add(medicament);
            _db.SaveChanges();
        }
        public void DeleteMedicament(int id)
        {
            var conToDel = GetMedicamentByID(id);
            _db.Medicament.Remove(conToDel);
            _db.SaveChanges();
        }
        public Medicament GetMedicamentByID(int id)
        {
            return _db.Medicament.FirstOrDefault(d => d.ID_Medicament == id);
        }
        public IEnumerable<Medicament> GetAllMedicament()
        {
            return _db.Medicament.ToList();
        }

        //Ordre
        public void CreateNewOrdre(Ordre ordre)
        {
            _db.Ordre.Add(ordre);
            _db.SaveChanges();
        }
        public void DeleteOrdre(int id)
        {
            var conToDel = GetOrdreByID(id);
            _db.Ordre.Remove(conToDel);
            _db.SaveChanges();
        }
        public Ordre GetOrdreByID(int id)
        {
            return _db.Ordre.FirstOrDefault(d => d.ID_Ordre == id);
        }
        public IEnumerable<Ordre> GetAllOrdre()
        {
            return _db.Ordre.ToList();

        }

        //Pacient
        public void CreateNewPacient(Pacient pacient)
        {
            _db.Pacient.Add(pacient);
            _db.SaveChanges();
        }
        public void DeletePacient(int id)
        {
            var conToDel = GetPacientByID(id);
            _db.Pacient.Remove(conToDel);
            _db.SaveChanges();
        }
        public Pacient GetPacientByID(int id)
        {
            return _db.Pacient.FirstOrDefault(d => d.ID_Pacient == id);

        }
        public IEnumerable<Pacient> GetAllPacient()
        {
            return _db.Pacient.ToList();
        }

        //Quirofan
        public void CreateNewQuirofan(Quirofan quirofan)
        {
            _db.Quirofan.Add(quirofan);
            _db.SaveChanges();
        }
        public void DeleteQuirofan(int id)
        {
            var conToDel = GetQuirofanByID(id);
            _db.Quirofan.Remove(conToDel);
            _db.SaveChanges();

        }
        public Quirofan GetQuirofanByID(int id)
        {
            return _db.Quirofan.FirstOrDefault(d => d.ID_Quirofan == id);
        }
        public IEnumerable<Quirofan> GetAllQuirofan()
        {
            return _db.Quirofan.ToList();

        }

        //Reserva
        public void CreateNewReserva(Reserva reserva)
        {
            _db.Reserva.Add(reserva);
            _db.SaveChanges();
        }
        public void DeleteReserva(int id)
        {
            var conToDel = GetReservaByID(id);
            _db.Reserva.Remove(conToDel);
            _db.SaveChanges();
        }
        public Reserva GetReservaByID(int id)
        {
            return _db.Reserva.FirstOrDefault(d => d.ID_Reserva == id);

        }
        public IEnumerable<Reserva> GetAllReserva()
        {
            return _db.Reserva.ToList();

        }

        //TipusEmpleat
        public void CreateNewTipusEmpleat(TipusEmpleat tipusEmpleat)
        {
            _db.TipusEmpleat.Add(tipusEmpleat);
            _db.SaveChanges();

        }
        public void DeleteTipusEmpleat(int id)
        {
            var conToDel = GetTipusEmpleatByID(id);
            _db.TipusEmpleat.Remove(conToDel);
            _db.SaveChanges();
        }
        public TipusEmpleat GetTipusEmpleatByID(int id)
        {
            return _db.TipusEmpleat.FirstOrDefault(d => d.ID_TipusEmpleat == id);
        }
        public IEnumerable<TipusEmpleat> GetAllTipusEmpleat()
        {
            return _db.TipusEmpleat.ToList();
        }

        //TipusOrdre
        public void CreateNewTipusOrdre(TipusOrdre tipusOrdre)
        {
            _db.TipusOrdre.Add(tipusOrdre);
            _db.SaveChanges();
        }
        public void DeleteTipusOrdre(int id)
        {
            var conToDel = GetTipusOrdreByID(id);
            _db.TipusOrdre.Remove(conToDel);
            _db.SaveChanges();
        }
        public TipusOrdre GetTipusOrdreByID(int id)
        {
            return _db.TipusOrdre.FirstOrDefault(d => d.ID_TipusOrdre == id);
        }
        public IEnumerable<TipusOrdre> GetAllTipusOrdre()
        {
            return _db.TipusOrdre.ToList();
        }

        //Tractament
        public void CreateNewTractament(Tractament tractament)
        {
            _db.Tractament.Add(tractament);
            _db.SaveChanges();

        }
        public void DeleteTractament(int id)
        {
            var conToDel = GetTractamentByID(id);
            _db.Tractament.Remove(conToDel);
            _db.SaveChanges();

        }
        public Tractament GetTractamentByID(int id)
        {
            return _db.Tractament.FirstOrDefault(d => d.ID_Tractament == id);
        }
        public IEnumerable<Tractament> GetAllTractament()
        {
            return _db.Tractament.ToList();
        }

        //Usuari
        public void CreateNewUsuari(Usuari usuari)
        {
            _db.Usuari.Add(usuari);
            _db.SaveChanges();
        }
        public void DeleteUsuari(int id)
        {
            var conToDel = GetUsuariByID(id);
            _db.Usuari.Remove(conToDel);
            _db.SaveChanges();

        }
        public Usuari GetUsuariByID(int id)
        {
            return _db.Usuari.FirstOrDefault(d => d.ID_Usuari == id);
        }
        public IEnumerable<Usuari> GetAllUsuari()
        {
            return _db.Usuari.ToList();
        }

        public int SaveChanges()
        {
            return _db.SaveChanges();

        }

    }
}