﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace GestioHospitalaria.Models
{
    public interface IGestioHospitalariaRepository
    {
        //AdministrarFarmac
        void CreateNewAdministrarFarmac(AdministrarFarmac administrarFarmac);
        void DeleteAdministrarFarmac(int id);
        AdministrarFarmac GetAdministrarFarmacByID(int id);
        IEnumerable<AdministrarFarmac> GetAllAdministrarFarmac();

        //Dosi
        void CreateNewDosi(Dosi dosi);
        void DeleteDosi(int id);
        Dosi GetDosiByID(int id);
        IEnumerable<Dosi> GetAllDosi();

        //EstatReserva
        void CreateNewEstatReserva(EstatReserva estatReserva);
        void DeleteEstatReserva(int id);
        EstatReserva GetEstatReservaByID(int id);
        IEnumerable<EstatReserva> GetAllEstatReserva();

        //Frequencia
        void CreateNewFrequencia(Frequencia frequencia);
        void DeleteFrequencia(int id);
        Frequencia GetFrequenciaByID(int id);
        IEnumerable<Frequencia> GetAllFrequencia();

        //Habitacio
        void CreateNewHabitacio(Habitacio habitacio);
        void DeleteHabitacio(int id);
        Habitacio GetHabitacioByID(int id);
        IEnumerable<Habitacio> GetAllHabitacio();

        //Ingres
        void CreateNewIngres(Ingres ingres);
        void DeleteIngres(int id);
        Ingres GetIngresByID(int id);
        IEnumerable<Ingres> GetAllIngres();

        //Medicament
        void CreateNewMedicament(Medicament medicament);
        void DeleteMedicament(int id);
        Medicament GetMedicamentByID(int id);
        IEnumerable<Medicament> GetAllMedicament();

        //Ordre
        void CreateNewOrdre(Ordre ordre);
        void DeleteOrdre(int id);
        Ordre GetOrdreByID(int id);
        IEnumerable<Ordre> GetAllOrdre();

        //Pacient
        void CreateNewPacient(Pacient pacient);
        void DeletePacient(int id);
        Pacient GetPacientByID(int id);
        IEnumerable<Pacient> GetAllPacient();

        //Quirofan
        void CreateNewQuirofan(Quirofan quirofan);
        void DeleteQuirofan(int id);
        Quirofan GetQuirofanByID(int id);
        IEnumerable<Quirofan> GetAllQuirofan();

        //Reserva
        void CreateNewReserva(Reserva reserva);
        void DeleteReserva(int id);
        Reserva GetReservaByID(int id);
        IEnumerable<Reserva> GetAllReserva();

        //TipusEmpleat
        void CreateNewTipusEmpleat(TipusEmpleat tipusEmpleat);
        void DeleteTipusEmpleat(int id);
        TipusEmpleat GetTipusEmpleatByID(int id);
        IEnumerable<TipusEmpleat> GetAllTipusEmpleat();

        //TipusOrdre
        void CreateNewTipusOrdre(TipusOrdre tipusOrdre);
        void DeleteTipusOrdre(int id);
        TipusOrdre GetTipusOrdreByID(int id);
        IEnumerable<TipusOrdre> GetAllTipusOrdre();

        //Tractament
        void CreateNewTractament(Tractament tractament);
        void DeleteTractament(int id);
        Tractament GetTractamentByID(int id);
        IEnumerable<Tractament> GetAllTractament();

        //Usuari
        void CreateNewUsuari(Usuari usuari);
        void DeleteUsuari(int id);
        Usuari GetUsuariByID(int id);
        IEnumerable<Usuari> GetAllUsuari();

        int SaveChanges();

    }
}